t / test-lib.shon commit http: extract type/subtype portion of content-type (bf197fd)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29else
  30        # ensure that TEST_DIRECTORY is an absolute path so that it
  31        # is valid even if the current working directory is changed
  32        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  33fi
  34if test -z "$TEST_OUTPUT_DIRECTORY"
  35then
  36        # Similarly, override this to store the test-results subdir
  37        # elsewhere
  38        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  39fi
  40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  41
  42################################################################
  43# It appears that people try to run tests without building...
  44"$GIT_BUILD_DIR/git" >/dev/null
  45if test $? != 1
  46then
  47        echo >&2 'error: you do not seem to have built git yet.'
  48        exit 1
  49fi
  50
  51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  52export PERL_PATH SHELL_PATH
  53
  54# if --tee was passed, write the output not only to the terminal, but
  55# additionally to the file test-results/$BASENAME.out, too.
  56case "$GIT_TEST_TEE_STARTED, $* " in
  57done,*)
  58        # do not redirect again
  59        ;;
  60*' --tee '*|*' --va'*)
  61        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  62        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  63        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  64         echo $? > $BASE.exit) | tee $BASE.out
  65        test "$(cat $BASE.exit)" = 0
  66        exit
  67        ;;
  68esac
  69
  70# For repeatability, reset the environment to known value.
  71LANG=C
  72LC_ALL=C
  73PAGER=cat
  74TZ=UTC
  75TERM=dumb
  76export LANG LC_ALL PAGER TERM TZ
  77EDITOR=:
  78# A call to "unset" with no arguments causes at least Solaris 10
  79# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  80# deriving from the command substitution clustered with the other
  81# ones.
  82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  83        my @env = keys %ENV;
  84        my $ok = join("|", qw(
  85                TRACE
  86                DEBUG
  87                USE_LOOKUP
  88                TEST
  89                .*_TEST
  90                PROVE
  91                VALGRIND
  92                UNZIP
  93                PERF_
  94                CURL_VERBOSE
  95        ));
  96        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  97        print join("\n", @vars);
  98')
  99unset XDG_CONFIG_HOME
 100unset GITPERLLIB
 101GIT_AUTHOR_EMAIL=author@example.com
 102GIT_AUTHOR_NAME='A U Thor'
 103GIT_COMMITTER_EMAIL=committer@example.com
 104GIT_COMMITTER_NAME='C O Mitter'
 105GIT_MERGE_VERBOSITY=5
 106GIT_MERGE_AUTOEDIT=no
 107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 110export EDITOR
 111
 112if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 113then
 114        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 115        export GIT_INDEX_VERSION
 116fi
 117
 118# Add libc MALLOC and MALLOC_PERTURB test
 119# only if we are not executing the test with valgrind
 120if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 121   test -n "$TEST_NO_MALLOC_CHECK"
 122then
 123        setup_malloc_check () {
 124                : nothing
 125        }
 126        teardown_malloc_check () {
 127                : nothing
 128        }
 129else
 130        setup_malloc_check () {
 131                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 132                export MALLOC_CHECK_ MALLOC_PERTURB_
 133        }
 134        teardown_malloc_check () {
 135                unset MALLOC_CHECK_ MALLOC_PERTURB_
 136        }
 137fi
 138
 139# Protect ourselves from common misconfiguration to export
 140# CDPATH into the environment
 141unset CDPATH
 142
 143unset GREP_OPTIONS
 144unset UNZIP
 145
 146case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1471|2|true)
 148        echo "* warning: Some tests will not work if GIT_TRACE" \
 149                "is set as to trace on STDERR ! *"
 150        echo "* warning: Please set GIT_TRACE to something" \
 151                "other than 1, 2 or true ! *"
 152        ;;
 153esac
 154
 155# Convenience
 156#
 157# A regexp to match 5 and 40 hexdigits
 158_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 159_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 160
 161# Zero SHA-1
 162_z40=0000000000000000000000000000000000000000
 163
 164# Line feed
 165LF='
 166'
 167
 168export _x05 _x40 _z40 LF
 169
 170# Each test should start with something like this, after copyright notices:
 171#
 172# test_description='Description of this test...
 173# This test checks if command xyzzy does the right thing...
 174# '
 175# . ./test-lib.sh
 176[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 177                TERM=$ORIGINAL_TERM &&
 178                export TERM &&
 179                [ -t 1 ] &&
 180                tput bold >/dev/null 2>&1 &&
 181                tput setaf 1 >/dev/null 2>&1 &&
 182                tput sgr0 >/dev/null 2>&1
 183        ) &&
 184        color=t
 185
 186while test "$#" -ne 0
 187do
 188        case "$1" in
 189        -d|--d|--de|--deb|--debu|--debug)
 190                debug=t; shift ;;
 191        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 192                immediate=t; shift ;;
 193        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 194                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 195        -h|--h|--he|--hel|--help)
 196                help=t; shift ;;
 197        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 198                verbose=t; shift ;;
 199        --verbose-only=*)
 200                verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 201                shift ;;
 202        -q|--q|--qu|--qui|--quie|--quiet)
 203                # Ignore --quiet under a TAP::Harness. Saying how many tests
 204                # passed without the ok/not ok details is always an error.
 205                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 206        --with-dashes)
 207                with_dashes=t; shift ;;
 208        --no-color)
 209                color=; shift ;;
 210        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 211                valgrind=memcheck
 212                shift ;;
 213        --valgrind=*)
 214                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 215                shift ;;
 216        --valgrind-only=*)
 217                valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 218                shift ;;
 219        --tee)
 220                shift ;; # was handled already
 221        --root=*)
 222                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 223                shift ;;
 224        *)
 225                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 226        esac
 227done
 228
 229if test -n "$valgrind_only"
 230then
 231        test -z "$valgrind" && valgrind=memcheck
 232        test -z "$verbose" && verbose_only="$valgrind_only"
 233elif test -n "$valgrind"
 234then
 235        verbose=t
 236fi
 237
 238if test -n "$color"
 239then
 240        say_color () {
 241                (
 242                TERM=$ORIGINAL_TERM
 243                export TERM
 244                case "$1" in
 245                error)
 246                        tput bold; tput setaf 1;; # bold red
 247                skip)
 248                        tput setaf 4;; # blue
 249                warn)
 250                        tput setaf 3;; # brown/yellow
 251                pass)
 252                        tput setaf 2;; # green
 253                info)
 254                        tput setaf 6;; # cyan
 255                *)
 256                        test -n "$quiet" && return;;
 257                esac
 258                shift
 259                printf "%s" "$*"
 260                tput sgr0
 261                echo
 262                )
 263        }
 264else
 265        say_color() {
 266                test -z "$1" && test -n "$quiet" && return
 267                shift
 268                printf "%s\n" "$*"
 269        }
 270fi
 271
 272error () {
 273        say_color error "error: $*"
 274        GIT_EXIT_OK=t
 275        exit 1
 276}
 277
 278say () {
 279        say_color info "$*"
 280}
 281
 282test "${test_description}" != "" ||
 283error "Test script did not set test_description."
 284
 285if test "$help" = "t"
 286then
 287        printf '%s\n' "$test_description"
 288        exit 0
 289fi
 290
 291exec 5>&1
 292exec 6<&0
 293if test "$verbose" = "t"
 294then
 295        exec 4>&2 3>&1
 296else
 297        exec 4>/dev/null 3>/dev/null
 298fi
 299
 300test_failure=0
 301test_count=0
 302test_fixed=0
 303test_broken=0
 304test_success=0
 305
 306test_external_has_tap=0
 307
 308die () {
 309        code=$?
 310        if test -n "$GIT_EXIT_OK"
 311        then
 312                exit $code
 313        else
 314                echo >&5 "FATAL: Unexpected exit with code $code"
 315                exit 1
 316        fi
 317}
 318
 319GIT_EXIT_OK=
 320trap 'die' EXIT
 321
 322# The user-facing functions are loaded from a separate file so that
 323# test_perf subshells can have them too
 324. "$TEST_DIRECTORY/test-lib-functions.sh"
 325
 326# You are not expected to call test_ok_ and test_failure_ directly, use
 327# the test_expect_* functions instead.
 328
 329test_ok_ () {
 330        test_success=$(($test_success + 1))
 331        say_color "" "ok $test_count - $@"
 332}
 333
 334test_failure_ () {
 335        test_failure=$(($test_failure + 1))
 336        say_color error "not ok $test_count - $1"
 337        shift
 338        printf '%s\n' "$*" | sed -e 's/^/#      /'
 339        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 340}
 341
 342test_known_broken_ok_ () {
 343        test_fixed=$(($test_fixed+1))
 344        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 345}
 346
 347test_known_broken_failure_ () {
 348        test_broken=$(($test_broken+1))
 349        say_color warn "not ok $test_count - $@ # TODO known breakage"
 350}
 351
 352test_debug () {
 353        test "$debug" = "" || eval "$1"
 354}
 355
 356match_pattern_list () {
 357        arg="$1"
 358        shift
 359        test -z "$*" && return 1
 360        for pattern_
 361        do
 362                case "$arg" in
 363                $pattern_)
 364                        return 0
 365                esac
 366        done
 367        return 1
 368}
 369
 370maybe_teardown_verbose () {
 371        test -z "$verbose_only" && return
 372        exec 4>/dev/null 3>/dev/null
 373        verbose=
 374}
 375
 376last_verbose=t
 377maybe_setup_verbose () {
 378        test -z "$verbose_only" && return
 379        if match_pattern_list $test_count $verbose_only
 380        then
 381                exec 4>&2 3>&1
 382                # Emit a delimiting blank line when going from
 383                # non-verbose to verbose.  Within verbose mode the
 384                # delimiter is printed by test_expect_*.  The choice
 385                # of the initial $last_verbose is such that before
 386                # test 1, we do not print it.
 387                test -z "$last_verbose" && echo >&3 ""
 388                verbose=t
 389        else
 390                exec 4>/dev/null 3>/dev/null
 391                verbose=
 392        fi
 393        last_verbose=$verbose
 394}
 395
 396maybe_teardown_valgrind () {
 397        test -z "$GIT_VALGRIND" && return
 398        GIT_VALGRIND_ENABLED=
 399}
 400
 401maybe_setup_valgrind () {
 402        test -z "$GIT_VALGRIND" && return
 403        if test -z "$valgrind_only"
 404        then
 405                GIT_VALGRIND_ENABLED=t
 406                return
 407        fi
 408        GIT_VALGRIND_ENABLED=
 409        if match_pattern_list $test_count $valgrind_only
 410        then
 411                GIT_VALGRIND_ENABLED=t
 412        fi
 413}
 414
 415test_eval_ () {
 416        # This is a separate function because some tests use
 417        # "return" to end a test_expect_success block early.
 418        eval </dev/null >&3 2>&4 "$*"
 419}
 420
 421test_run_ () {
 422        test_cleanup=:
 423        expecting_failure=$2
 424        setup_malloc_check
 425        test_eval_ "$1"
 426        eval_ret=$?
 427        teardown_malloc_check
 428
 429        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 430        then
 431                setup_malloc_check
 432                test_eval_ "$test_cleanup"
 433                teardown_malloc_check
 434        fi
 435        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 436        then
 437                echo ""
 438        fi
 439        return "$eval_ret"
 440}
 441
 442test_start_ () {
 443        test_count=$(($test_count+1))
 444        maybe_setup_verbose
 445        maybe_setup_valgrind
 446}
 447
 448test_finish_ () {
 449        echo >&3 ""
 450        maybe_teardown_valgrind
 451        maybe_teardown_verbose
 452}
 453
 454test_skip () {
 455        to_skip=
 456        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 457        then
 458                to_skip=t
 459        fi
 460        if test -z "$to_skip" && test -n "$test_prereq" &&
 461           ! test_have_prereq "$test_prereq"
 462        then
 463                to_skip=t
 464        fi
 465        case "$to_skip" in
 466        t)
 467                of_prereq=
 468                if test "$missing_prereq" != "$test_prereq"
 469                then
 470                        of_prereq=" of $test_prereq"
 471                fi
 472
 473                say_color skip >&3 "skipping test: $@"
 474                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 475                : true
 476                ;;
 477        *)
 478                false
 479                ;;
 480        esac
 481}
 482
 483# stub; perf-lib overrides it
 484test_at_end_hook_ () {
 485        :
 486}
 487
 488test_done () {
 489        GIT_EXIT_OK=t
 490
 491        if test -z "$HARNESS_ACTIVE"
 492        then
 493                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 494                mkdir -p "$test_results_dir"
 495                base=${0##*/}
 496                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 497
 498                cat >>"$test_results_path" <<-EOF
 499                total $test_count
 500                success $test_success
 501                fixed $test_fixed
 502                broken $test_broken
 503                failed $test_failure
 504
 505                EOF
 506        fi
 507
 508        if test "$test_fixed" != 0
 509        then
 510                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 511        fi
 512        if test "$test_broken" != 0
 513        then
 514                say_color warn "# still have $test_broken known breakage(s)"
 515        fi
 516        if test "$test_broken" != 0 || test "$test_fixed" != 0
 517        then
 518                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 519                msg="remaining $test_remaining test(s)"
 520        else
 521                test_remaining=$test_count
 522                msg="$test_count test(s)"
 523        fi
 524        case "$test_failure" in
 525        0)
 526                # Maybe print SKIP message
 527                if test -n "$skip_all" && test $test_count -gt 0
 528                then
 529                        error "Can't use skip_all after running some tests"
 530                fi
 531                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 532
 533                if test $test_external_has_tap -eq 0
 534                then
 535                        if test $test_remaining -gt 0
 536                        then
 537                                say_color pass "# passed all $msg"
 538                        fi
 539                        say "1..$test_count$skip_all"
 540                fi
 541
 542                test -d "$remove_trash" &&
 543                cd "$(dirname "$remove_trash")" &&
 544                rm -rf "$(basename "$remove_trash")"
 545
 546                test_at_end_hook_
 547
 548                exit 0 ;;
 549
 550        *)
 551                if test $test_external_has_tap -eq 0
 552                then
 553                        say_color error "# failed $test_failure among $msg"
 554                        say "1..$test_count"
 555                fi
 556
 557                exit 1 ;;
 558
 559        esac
 560}
 561
 562if test -n "$valgrind"
 563then
 564        make_symlink () {
 565                test -h "$2" &&
 566                test "$1" = "$(readlink "$2")" || {
 567                        # be super paranoid
 568                        if mkdir "$2".lock
 569                        then
 570                                rm -f "$2" &&
 571                                ln -s "$1" "$2" &&
 572                                rm -r "$2".lock
 573                        else
 574                                while test -d "$2".lock
 575                                do
 576                                        say "Waiting for lock on $2."
 577                                        sleep 1
 578                                done
 579                        fi
 580                }
 581        }
 582
 583        make_valgrind_symlink () {
 584                # handle only executables, unless they are shell libraries that
 585                # need to be in the exec-path.
 586                test -x "$1" ||
 587                test "# " = "$(head -c 2 <"$1")" ||
 588                return;
 589
 590                base=$(basename "$1")
 591                symlink_target=$GIT_BUILD_DIR/$base
 592                # do not override scripts
 593                if test -x "$symlink_target" &&
 594                    test ! -d "$symlink_target" &&
 595                    test "#!" != "$(head -c 2 < "$symlink_target")"
 596                then
 597                        symlink_target=../valgrind.sh
 598                fi
 599                case "$base" in
 600                *.sh|*.perl)
 601                        symlink_target=../unprocessed-script
 602                esac
 603                # create the link, or replace it if it is out of date
 604                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 605        }
 606
 607        # override all git executables in TEST_DIRECTORY/..
 608        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 609        mkdir -p "$GIT_VALGRIND"/bin
 610        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 611        do
 612                make_valgrind_symlink $file
 613        done
 614        # special-case the mergetools loadables
 615        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 616        OLDIFS=$IFS
 617        IFS=:
 618        for path in $PATH
 619        do
 620                ls "$path"/git-* 2> /dev/null |
 621                while read file
 622                do
 623                        make_valgrind_symlink "$file"
 624                done
 625        done
 626        IFS=$OLDIFS
 627        PATH=$GIT_VALGRIND/bin:$PATH
 628        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 629        export GIT_VALGRIND
 630        GIT_VALGRIND_MODE="$valgrind"
 631        export GIT_VALGRIND_MODE
 632        GIT_VALGRIND_ENABLED=t
 633        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 634        export GIT_VALGRIND_ENABLED
 635elif test -n "$GIT_TEST_INSTALLED"
 636then
 637        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 638        error "Cannot run git from $GIT_TEST_INSTALLED."
 639        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 640        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 641else # normal case, use ../bin-wrappers only unless $with_dashes:
 642        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 643        if ! test -x "$git_bin_dir/git"
 644        then
 645                if test -z "$with_dashes"
 646                then
 647                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 648                fi
 649                with_dashes=t
 650        fi
 651        PATH="$git_bin_dir:$PATH"
 652        GIT_EXEC_PATH=$GIT_BUILD_DIR
 653        if test -n "$with_dashes"
 654        then
 655                PATH="$GIT_BUILD_DIR:$PATH"
 656        fi
 657fi
 658GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 659GIT_CONFIG_NOSYSTEM=1
 660GIT_ATTR_NOSYSTEM=1
 661export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 662
 663if test -z "$GIT_TEST_CMP"
 664then
 665        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 666        then
 667                GIT_TEST_CMP="$DIFF -c"
 668        else
 669                GIT_TEST_CMP="$DIFF -u"
 670        fi
 671fi
 672
 673GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 674export GITPERLLIB
 675test -d "$GIT_BUILD_DIR"/templates/blt || {
 676        error "You haven't built things yet, have you?"
 677}
 678
 679if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 680then
 681        echo >&2 'You need to build test-chmtime:'
 682        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 683        exit 1
 684fi
 685
 686# Test repository
 687TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 688test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 689case "$TRASH_DIRECTORY" in
 690/*) ;; # absolute path is good
 691 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 692esac
 693test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 694rm -fr "$TRASH_DIRECTORY" || {
 695        GIT_EXIT_OK=t
 696        echo >&5 "FATAL: Cannot prepare test area"
 697        exit 1
 698}
 699
 700HOME="$TRASH_DIRECTORY"
 701export HOME
 702
 703if test -z "$TEST_NO_CREATE_REPO"
 704then
 705        test_create_repo "$TRASH_DIRECTORY"
 706else
 707        mkdir -p "$TRASH_DIRECTORY"
 708fi
 709# Use -P to resolve symlinks in our working directory so that the cwd
 710# in subprocesses like git equals our $PWD (for pathname comparisons).
 711cd -P "$TRASH_DIRECTORY" || exit 1
 712
 713this_test=${0##*/}
 714this_test=${this_test%%-*}
 715if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 716then
 717        say_color info >&3 "skipping test $this_test altogether"
 718        skip_all="skip all tests in $this_test"
 719        test_done
 720fi
 721
 722# Provide an implementation of the 'yes' utility
 723yes () {
 724        if test $# = 0
 725        then
 726                y=y
 727        else
 728                y="$*"
 729        fi
 730
 731        while echo "$y"
 732        do
 733                :
 734        done
 735}
 736
 737# Fix some commands on Windows
 738case $(uname -s) in
 739*MINGW*)
 740        # Windows has its own (incompatible) sort and find
 741        sort () {
 742                /usr/bin/sort "$@"
 743        }
 744        find () {
 745                /usr/bin/find "$@"
 746        }
 747        sum () {
 748                md5sum "$@"
 749        }
 750        # git sees Windows-style pwd
 751        pwd () {
 752                builtin pwd -W
 753        }
 754        # no POSIX permissions
 755        # backslashes in pathspec are converted to '/'
 756        # exec does not inherit the PID
 757        test_set_prereq MINGW
 758        test_set_prereq NOT_CYGWIN
 759        test_set_prereq SED_STRIPS_CR
 760        test_set_prereq GREP_STRIPS_CR
 761        GIT_TEST_CMP=mingw_test_cmp
 762        ;;
 763*CYGWIN*)
 764        test_set_prereq POSIXPERM
 765        test_set_prereq EXECKEEPSPID
 766        test_set_prereq NOT_MINGW
 767        test_set_prereq CYGWIN
 768        test_set_prereq SED_STRIPS_CR
 769        test_set_prereq GREP_STRIPS_CR
 770        ;;
 771*)
 772        test_set_prereq POSIXPERM
 773        test_set_prereq BSLASHPSPEC
 774        test_set_prereq EXECKEEPSPID
 775        test_set_prereq NOT_MINGW
 776        test_set_prereq NOT_CYGWIN
 777        ;;
 778esac
 779
 780( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 781test -z "$NO_PERL" && test_set_prereq PERL
 782test -z "$NO_PYTHON" && test_set_prereq PYTHON
 783test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 784test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 785
 786# Can we rely on git's output in the C locale?
 787if test -n "$GETTEXT_POISON"
 788then
 789        GIT_GETTEXT_POISON=YesPlease
 790        export GIT_GETTEXT_POISON
 791        test_set_prereq GETTEXT_POISON
 792else
 793        test_set_prereq C_LOCALE_OUTPUT
 794fi
 795
 796# Use this instead of test_cmp to compare files that contain expected and
 797# actual output from git commands that can be translated.  When running
 798# under GETTEXT_POISON this pretends that the command produced expected
 799# results.
 800test_i18ncmp () {
 801        test -n "$GETTEXT_POISON" || test_cmp "$@"
 802}
 803
 804# Use this instead of "grep expected-string actual" to see if the
 805# output from a git command that can be translated either contains an
 806# expected string, or does not contain an unwanted one.  When running
 807# under GETTEXT_POISON this pretends that the command produced expected
 808# results.
 809test_i18ngrep () {
 810        if test -n "$GETTEXT_POISON"
 811        then
 812            : # pretend success
 813        elif test "x!" = "x$1"
 814        then
 815                shift
 816                ! grep "$@"
 817        else
 818                grep "$@"
 819        fi
 820}
 821
 822test_lazy_prereq PIPE '
 823        # test whether the filesystem supports FIFOs
 824        case $(uname -s) in
 825        CYGWIN*)
 826                false
 827                ;;
 828        *)
 829                rm -f testfifo && mkfifo testfifo
 830                ;;
 831        esac
 832'
 833
 834test_lazy_prereq SYMLINKS '
 835        # test whether the filesystem supports symbolic links
 836        ln -s x y && test -h y
 837'
 838
 839test_lazy_prereq FILEMODE '
 840        test "$(git config --bool core.filemode)" = true
 841'
 842
 843test_lazy_prereq CASE_INSENSITIVE_FS '
 844        echo good >CamelCase &&
 845        echo bad >camelcase &&
 846        test "$(cat CamelCase)" != good
 847'
 848
 849test_lazy_prereq UTF8_NFD_TO_NFC '
 850        # check whether FS converts nfd unicode to nfc
 851        auml=$(printf "\303\244")
 852        aumlcdiar=$(printf "\141\314\210")
 853        >"$auml" &&
 854        case "$(echo *)" in
 855        "$aumlcdiar")
 856                true ;;
 857        *)
 858                false ;;
 859        esac
 860'
 861
 862test_lazy_prereq AUTOIDENT '
 863        sane_unset GIT_AUTHOR_NAME &&
 864        sane_unset GIT_AUTHOR_EMAIL &&
 865        git var GIT_AUTHOR_IDENT
 866'
 867
 868# When the tests are run as root, permission tests will report that
 869# things are writable when they shouldn't be.
 870test -w / || test_set_prereq SANITY
 871
 872GIT_UNZIP=${GIT_UNZIP:-unzip}
 873test_lazy_prereq UNZIP '
 874        "$GIT_UNZIP" -v
 875        test $? -ne 127
 876'